'use strict';

var _extends = require('babel-runtime/helpers/extends')['default'];

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _utilsBootstrapUtils = require('./utils/bootstrapUtils');

var _utilsBootstrapUtils2 = _interopRequireDefault(_utilsBootstrapUtils);

var _domHelpersUtilScrollbarSize = require('dom-helpers/util/scrollbarSize');

var _domHelpersUtilScrollbarSize2 = _interopRequireDefault(_domHelpersUtilScrollbarSize);

var _domHelpersUtilInDOM = require('dom-helpers/util/inDOM');

var _domHelpersUtilInDOM2 = _interopRequireDefault(_domHelpersUtilInDOM);

var _domHelpersOwnerDocument = require('dom-helpers/ownerDocument');

var _domHelpersOwnerDocument2 = _interopRequireDefault(_domHelpersOwnerDocument);

var _domHelpersEvents = require('dom-helpers/events');

var _domHelpersEvents2 = _interopRequireDefault(_domHelpersEvents);

var _Fade = require('./Fade');

var _Fade2 = _interopRequireDefault(_Fade);

var _reactOverlaysLibModal = require('react-overlays/lib/Modal');

var _reactOverlaysLibModal2 = _interopRequireDefault(_reactOverlaysLibModal);

var _reactOverlaysLibUtilsIsOverflowing = require('react-overlays/lib/utils/isOverflowing');

var _reactOverlaysLibUtilsIsOverflowing2 = _interopRequireDefault(_reactOverlaysLibUtilsIsOverflowing);

var Loading = _react2['default'].createClass({
  displayName: 'Loading',

  getDefaultProps: function getDefaultProps() {
    return _extends({}, _reactOverlaysLibModal2['default'].defaultProps, {
      bsClass: 'modal',
      animation: true
    });
  },
  getInitialState: function getInitialState() {
    return {
      modalStyles: {}
    };
  },
  render: function render() {
    return null;
  },

  componentDidUpdate: function componentDidUpdate() {
    this.renderLoading();
  },

  componentDidMount: function componentDidMount() {
    this.renderLoading();
  },

  renderLoading: function renderLoading() {
    var _this2 = this;

    var _props = this.props;
    var className = _props.className;
    var children = _props.children;
    var animation = _props.animation;
    var containerId = _props.containerId;
    var containerRef = _props.containerRef;

    var props = _objectWithoutProperties(_props, ['className', 'children', 'animation', 'containerId', 'containerRef']);

    var modalStyles = this.state.modalStyles;

    var _this = this;

    var inClass = { 'in': props.show && !animation };

    var container = undefined;
    if (containerRef) {
      container = _reactDom2['default'].findDOMNode(containerRef);
    } else if (containerId) {
      container = document.getElementById(containerId);
    }

    var loading = _react2['default'].createElement(
      'div',
      {
        className: 'loadingWrap',
        style: modalStyles,
        ref: function (ref) {
          return _this2._loading = ref;
        } },
      _react2['default'].createElement('span', { className: 'loading-icon' }),
      children ? _react2['default'].createElement(
        'p',
        null,
        children
      ) : null
    );

    var loadingModal = _react2['default'].createElement(
      _reactOverlaysLibModal2['default'],
      {
        role: 'loadingModal',
        show: props.show,
        ref: function (ref) {
          _this2._wrapper = ref && ref.refs.modal;
          _this2._backdrop = ref && ref.refs.backdrop;
          _this2._loadingModal = ref;
        },
        onEntering: this._onShow,
        onExited: this._onHide,
        backdropClassName: _classnames2['default'](_utilsBootstrapUtils2['default'].prefix(props, 'backdrop'), inClass),
        container: container,
        containerClassName: _utilsBootstrapUtils2['default'].prefix(props, 'open'),
        transition: animation ? _Fade2['default'] : undefined,
        dialogTransitionTimeout: Loading.TRANSITION_DURATION,
        backdropTransitionTimeout: Loading.BACKDROP_TRANSITION_DURATION
      },
      loading
    );

    this._mountLoadingTarget();
    _reactDom2['default'].unstable_renderSubtreeIntoContainer(this, loadingModal, this._loadingTarget);
  },

  _mountLoadingTarget: function _mountLoadingTarget() {
    if (!this._loadingTarget) {
      this._loadingTarget = document.createElement('div');
      this._getLoadingContainerDOMNode().appendChild(this._loadingTarget);
    }
  },

  _getLoadingContainerDOMNode: function _getLoadingContainerDOMNode() {
    var node = _reactDom2['default'].findDOMNode(this),
        body = document.body;
    return node ? node.parentNode || body : body;
  },

  _onShow: function _onShow() {
    _domHelpersEvents2['default'].on(window, 'resize', this.handleWindowResize);

    this.setState(this._getStyles());

    if (this.props.onEntering) {
      var _props2;

      (_props2 = this.props).onEntering.apply(_props2, arguments);
    }
  },

  _onHide: function _onHide() {
    _domHelpersEvents2['default'].off(window, 'resize', this.handleWindowResize);

    if (this.props.onExited) {
      var _props3;

      (_props3 = this.props).onExited.apply(_props3, arguments);
    }
  },

  handleWindowResize: function handleWindowResize() {
    this.setState(this._getStyles());
  },

  _getStyles: function _getStyles() {
    if (!_domHelpersUtilInDOM2['default']) {
      return {};
    }

    var node = _reactDom2['default'].findDOMNode(this._loading);
    var doc = _domHelpersOwnerDocument2['default'](node);

    var scrollHt = node.scrollHeight;
    var bodyIsOverflowing = _reactOverlaysLibUtilsIsOverflowing2['default'](_reactDom2['default'].findDOMNode(this.props.container || doc.body));
    var modalIsOverflowing = scrollHt > doc.documentElement.clientHeight;

    return {
      modalStyles: {
        marginTop: -node.offsetHeight / 2,
        marginLeft: -node.offsetWidth / 2,
        paddingRight: bodyIsOverflowing && !modalIsOverflowing ? _domHelpersUtilScrollbarSize2['default']() : void 0,
        paddingLeft: !bodyIsOverflowing && modalIsOverflowing ? _domHelpersUtilScrollbarSize2['default']() : void 0
      }
    };
  }
});

Loading.TRANSITION_DURATION = 300;
Loading.BACKDROP_TRANSITION_DURATION = 150;

exports['default'] = _utilsBootstrapUtils.bsClass('loading', Loading);
module.exports = exports['default'];